;Project Lynxmotion Phoenix
;Description: chr-3, configuration file.
;		All Hardware connections (excl controls) and body dimensions 
;		are configurated in this file. Can be used with V2.0 and above
;Configuration version: V1.0
;Date: Nov 1, 2009
;Programmer: Jeroen Janssen (aka Xan) - modified for CHR-3 by Kurt (aka KurtE)
;
;Hardware setup: ABB2 with ATOM 28 Pro, SSC32 V2, (See further for connections)
;
;NEW IN V1.0
;	- First Release
;
;--------------------------------------------------------------------
;[BAP28 or BAP40?]
; try to make run on a BAP40! by KurtE
#ifdef TMA
BAP28	con	1
#else
BAP40	con	1		; define something for BAP40
#endif

;[SERIAL CONNECTIONS]
cSSC_OUT   		con P11		;Output pin for (SSC32 RX) on BotBoard (Yellow)
cSSC_IN    		con P10		;Input pin for (SSC32 TX) on BotBoard (Blue)
;
; Set SSC_USE_TASERIAL if you want to use the timer assisted serial
; to talk to the SSC-32 at high speed
SSC_USE_TASERIAL	con 1

#ifdef SSC_USE_TASERIAL
USETASERIAL		con 1		; make sure TASERIAL SUPPORT is enabled.
cSSC_BAUD		con	i115200	; try real fast!
#else
cSSC_BAUD 		con i38400	;SSC32 BAUD rate
#endif

;--------------------------------------------------------------------
;[BB2 PIN NUMBERS]
;cControlIOPin	con	P13		; Pin to try to enable or disable XBEE...
cEyesPin		con P8
;--------------------------------------------------------------------
;[SSC PIN NUMBERS]
cRRCoxaPin 		con P0	;Rear Right leg Hip Horizontal
cRRFemurPin 	con P1	;Rear Right leg Hip Vertical
cRRTibiaPin 	con P2	;Rear Right leg Knee

cRMCoxaPin 		con P4	;Middle Right leg Hip Horizontal
cRMFemurPin 	con P5	;Middle Right leg Hip Vertical
cRMTibiaPin 	con P6	;Middle Right leg Knee

cRFCoxaPin 		con P8	;Front Right leg Hip Horizontal
cRFFemurPin 	con P9	;Front Right leg Hip Vertical
cRFTibiaPin 	con P10	;Front Right leg Knee

cLRCoxaPin 		con P16	;Rear Left leg Hip Horizontal
cLRFemurPin 	con P17	;Rear Left leg Hip Vertical
cLRTibiaPin 	con P18	;Rear Left leg Knee

cLMCoxaPin 		con P20	;Middle Left leg Hip Horizontal
cLMFemurPin 	con P21	;Middle Left leg Hip Vertical
cLMTibiaPin 	con P22	;Middle Left leg Knee

cLFCoxaPin 		con P24	;Front Left leg Hip Horizontal
cLFFemurPin 	con P25	;Front Left leg Hip Vertical
cLFTibiaPin 	con P26	;Front Left leg Knee
;--------------------------------------------------------------------
;[MIN/MAX ANGLES]
cRRCoxaMin1		con -750		;Mechanical limits of the Right Rear Leg
cRRCoxaMax1		con 750
cRRFemurMin1	con -900
cRRFemurMax1	con 550
cRRTibiaMin1	con -500
cRRTibiaMax1	con 750

cRMCoxaMin1		con -750		;Mechanical limits of the Right Middle Leg
cRMCoxaMax1		con 750
cRMFemurMin1	con -900
cRMFemurMax1	con 550
cRMTibiaMin1	con -500
cRMTibiaMax1	con 750

cRFCoxaMin1		con -750		;Mechanical limits of the Right Front Leg
cRFCoxaMax1		con 750
cRFFemurMin1	con -900
cRFFemurMax1	con 550
cRFTibiaMin1	con -500
cRFTibiaMax1	con 750

cLRCoxaMin1		con -750		;Mechanical limits of the Left Rear Leg
cLRCoxaMax1		con 750
cLRFemurMin1	con -900
cLRFemurMax1	con 550
cLRTibiaMin1	con -500
cLRTibiaMax1	con 750

cLMCoxaMin1		con -750		;Mechanical limits of the Left Middle Leg
cLMCoxaMax1		con 750
cLMFemurMin1	con -900
cLMFemurMax1	con 550
cLMTibiaMin1	con -500
cLMTibiaMax1	con 750

cLFCoxaMin1		con -750		;Mechanical limits of the Left Front Leg
cLFCoxaMax1		con 750
cLFFemurMin1	con -900
cLFFemurMax1	con 550
cLFTibiaMin1	con -500
cLFTibiaMax1	con 750
;--------------------------------------------------------------------
;[BODY DIMENSIONS]
cCoxaLength 	con 29      ;1.14" = 29mm (1.14 * 25.4)
cFemurLength 	con  57     ;2.25" = 57mm (2.25 * 25.4)
cTibiaLength 	con  141    ;5.55" = 141mm (5.55 * 25.4)

cRRCoxaAngle1 	con -600	;Default Coxa setup angle, decimals = 1
cRMCoxaAngle1 	con 0		;Default Coxa setup angle, decimals = 1
cRFCoxaAngle1 	con 600		;Default Coxa setup angle, decimals = 1
cLRCoxaAngle1 	con -600	;Default Coxa setup angle, decimals = 1
cLMCoxaAngle1 	con 0		;Default Coxa setup angle, decimals = 1
cLFCoxaAngle1 	con 600		;Default Coxa setup angle, decimals = 1

cRROffsetX 		con -69     ;Distance X from center of the body to the Right Rear coxa
cRROffsetZ 		con 119     ;Distance Z from center of the body to the Right Rear coxa
cRMOffsetX 		con -138    ;Distance X from center of the body to the Right Middle coxa
cRMOffsetZ 		con 0       ;Distance Z from center of the body to the Right Middle coxa
cRFOffsetX 		con -69     ;Distance X from center of the body to the Right Front coxa
cRFOffsetZ 		con -119    ;Distance Z from center of the body to the Right Front coxa

cLROffsetX 		con 69      ;Distance X from center of the body to the Left Rear coxa
cLROffsetZ 		con 119     ;Distance Z from center of the body to the Left Rear coxa
cLMOffsetX 		con 138     ;Distance X from center of the body to the Left Middle coxa
cLMOffsetZ 		con 0       ;Distance Z from center of the body to the Left Middle coxa
cLFOffsetX 		con 69      ;Distance X from center of the body to the Left Front coxa
cLFOffsetZ 		con -119    ;Distance Z from center of the body to the Left Front coxa

;--------------------------------------------------------------------
;[START POSITIONS FEET]
cHexInitXZ		con 105		; was 105 
CHexInitY		con 80

cRRInitPosX 	con (cHexInitXZ * 0.5 + 0.5)		;Start positions of the Right Rear leg
cRRInitPosY 	con cHexInitY
cRRInitPosZ 	con (cHexInitXZ * 0.866 + 0.5)

cRMInitPosX 	con cHexInitXZ		;Start positions of the Right Middle leg
cRMInitPosY 	con cHexInitY
cRMInitPosZ 	con 0

cRFInitPosX 	con (cHexInitXZ * 0.5 + 0.5)		;Start positions of the Right Front leg
cRFInitPosY 	con cHexInitY
cRFInitPosZ 	con -(cHexInitXZ * 0.866 + 0.5)

cLRInitPosX 	con (cHexInitXZ * 0.5 + 0.5)		;Start positions of the Left Rear leg
cLRInitPosY 	con cHexInitY
cLRInitPosZ 	con (cHexInitXZ * 0.866 + 0.5)

cLMInitPosX 	con cHexInitXZ		;Start positions of the Left Middle leg
cLMInitPosY 	con cHexInitY
cLMInitPosZ 	con 0

cLFInitPosX 	con (cHexInitXZ * 0.5 + 0.5)		;Start positions of the Left Front leg
cLFInitPosY 	con cHexInitY
cLFInitPosZ 	con -(cHexInitXZ * 0.866 + 0.5)
;--------------------------------------------------------------------