XBEEONHSERIAL	con 1   ; try this version first...
; We will predefine these so we can add our own XBEE functions here to test...
cXBEE_IN				con	p14		; The input pin
cXBEE_OUT				con	p15		; the output pin

CXBEE_RTS				con	p7
#ifdef XBEEONHSERIAL
CXBEE_BAUD				con H62500				; Non-standard baud rate for xbee but...
#else
cXBEE_BAUD				con i57600				; now using standard serial
#endif	; XBEEONHSERIAL


; First lets define the Nodes.  For now lets do it quick and simple!
CMAXNDLIST	con	10						; currently the max number of nodes we will cache
CBNIMAX		con	12						; currently we will only keep 12 bytes per name

cNDList		var	sword					; how many items are in our list?
csNDList	var	byte					; checksum of data.
i			var byte

awNDMY		var	word(CMAXNDLIST)		; Keep a list of all of the Mys
alNDSNL		var	long(CMAXNDLIST)		; Serial numbers Low
alNDSNH		var	long(CMAXNDLIST)		; Serial Numbers High
abNDNIS		var	byte(CMAXNDLIST*CBNIMAX) ; keep all of the strings...
;==============================================================================
; [EEPROM] Define EEPROM memory locations
;==============================================================================
JoystickRangesDMStart	con	0x0		; 12 bytes - Stores Mins/Maxs of joysticks/sliders
XBeeDMStart				con	0x80	; 4 Bytes - Stores the XBee My and DL we want

XBeeNDDMCache			con	0x88	; 2 bytes - (count and checksum) How many items do we have cached out
									; followed by My array, SNL, SNH, and text strings... reserve 220 bytes for this!


    Sound 9,[60\4000,80\4500,100\5000]

	cNDList = 0;		// start off with no items
#ifdef BASICATOMPRO28	
	serout s_out, i9600, [13, 13, "XBee Test Program", 13]
#else
	enablehserial	
	SetHSerial H38400,H8DATABITS,HNOPARITY,H1STOPBITS
	hserout [13, 13, "XBee Test Program", 13]
#endif
	
	gosub InitXBee

main:
	hserout [13, 13, "Call Update NDList", 13]
	gosub ClearInputBuffer

	gosub UpdateNDListFromXBee
#ifdef BASICATOMPRO28	
	serout s_out, i9600, ["Count of nodes: ", dec cNDList, 13]
	if cNDLIST then
		for i = 0 to cNDList-1
			serout s_out, i9600, ["My: ", hex awNDMY(i)," SN: ", hex alNDSNH(i), hex8 alNDSNL(i)\8, " ", str abNDNIS(i*CBNIMAX)\CBNIMAX, 13];
		next
	endif
#else
	hserout ["Count of nodes: ", dec cNDList, 13]
	if cNDList then
		for i = 0 to cNDList-1
			hserout ["My: ", hex awNDMY(i)," SN: ", hex alNDSNH(i), hex8 alNDSNL(i)\8, " ", str abNDNIS(i*CBNIMAX)\CBNIMAX, 13];
		next
	endif
#endif	
	pause 5000
	goto main

;==============================================================================
; ReadSavedXBeeNDList - Read in the ND List that we have samed in the EEPROM.
;==============================================================================

_csin			var	byte
_i				var	byte
_j				var	byte
_bNDLT			var	byte(20)					; temporary string to read thigns into...
_cNDListIn		var	byte						; count of items that were read in from EEPROM
_wNDSS			var	word						; signal strength, don't care...
_fItemDup		var	bit							; Have we seen this item before?
_fListChanged	var	bit							; have we changed the list

    
;==============================================================================
; [UpdateNDListFromXBee] - This function will update the ND list using information
; 		it receives back from issuing an ATND command.  It may add new nodes or
;		if it finds nodes with a serial number that matches, but data is different
;		it will update that information as well.
;==============================================================================
_cbRet	var	sword

UpdateNDListFromXBee:	
	_cNDListIn = cNDList	; remember how many we had from EEPROM (no need to check dups of items beyond this)


	; use same helper function to send command as our get functions
	gosub APISendXBeeGetCmd["N","D"]
	
	; I think I can loop calling the APIRecvPacket - but as the data it returns is in a differet
	; file, I may have to have helper function over there.
	repeat
		APIRECVDATAOFFSET con 5
		gosub APIRecvPacket[3000000], _cbRet
		if _cbret > (11+APIRECVDATAOFFSET) then ; MY(2), SH(4), SL(4), DB(1), NI???
#if 0
			for i = 0 to _cbret
				hserout [hex _bAPIPacket(i)\2," "];
			next
			hserout [13]		
#endif				
			; ok lets extract the information for this item
			; Note with the API receive packet we need to skip over the header part of the API receive.
			awNDMY(cNDList) = (_bAPIPacket(APIRECVDATAOFFSET+0) << 8) + _bAPIPacket(APIRECVDATAOFFSET+1)
			alNDSNH(cNDList) = (_bAPIPacket(APIRECVDATAOFFSET+2) << 24) + (_bAPIPacket(APIRECVDATAOFFSET+3) << 16) + (_bAPIPacket(APIRECVDATAOFFSET+4) << 8) + _bAPIPacket(APIRECVDATAOFFSET+5)		
			alNDSNL(cNDList) = (_bAPIPacket(APIRECVDATAOFFSET+6) << 24) + (_bAPIPacket(APIRECVDATAOFFSET+7) << 16) + (_bAPIPacket(APIRECVDATAOFFSET+8) << 8) + _bAPIPacket(APIRECVDATAOFFSET+9)		
			
			;hserout [hex awNDMy(cNDList), " ", hex alNDSNH(cNDList),hex8 alNDSNL(cNDList)\8, 13]
			; The Node identifier starts in bTemp(11)
			; We want to blank this field out to our default size we use
			_i = _cbRet - (12+APIRECVDATAOFFSET)	; number of actual characters transfered.
			while _i < CBNIMAX
				_bAPIPacket(_i+11+APIRECVDATAOFFSET) = " "
				_i = _i + 1
			wend  

			_fItemDup = 0
			if _cNDListIn then
				for _i = 0 to _cNDListIn-1
					if (alNDSNH(_i) = alNDSNH(cNDList)) and (alNDSNL(_i) = alNDSNL(cNDList)) then
						; We have seen this one before...
						_fItemDup = 1; 		; signal that this item is a duplicate...
			
						; but we will also make sure the MY or the NI has not changed.
						if (awNDMY(_i) <> awNDMY(cNDList)) then
							_fListChanged = 1; 	we know that we need to write the stuff back out...
							awNDMY(_i) = awNDMY(cNDList)
						endif
						for _j = 0 to CBNIMAX-1
							if abNDNIS(_i*CBNIMAX + _j) <> _bAPIPacket(_j+11+APIRECVDATAOFFSET) then
								abNDNIS(_i*CBNIMAX + _j) = _bAPIPacket(_j+11+APIRECVDATAOFFSET)
								_fListChanged = 1; 	we know that we need to write the stuff back out...
							endif
						next
					endif
				next
			endif
			; only save away the data if this is not a duplicate and we have room
			if (_fItemDup = 0) and  (cNDList < CMAXNDLIST) then
				for _j = 0 to CBNIMAX-1			; copy the NI string in.
					abNDNIS(cNDList*CBNIMAX + _j) = _bAPIPacket(_j+11+APIRECVDATAOFFSET)
				next
				cNDList = cNDList + 1
				_fListChanged = 1	; yes the list changed - have new node
			endif
		endif
	until _cbret <= (11+APIRECVDATAOFFSET) ; MY(2), SH(4), SL(4), DB(1), NI???
						
	return
